﻿// Etiquetas Pedido antigua, se mantiene para un futuro uso

$(document).ready(function () {
    var txtPedido = $('#txtPedido');
    var txtCliente = $('#txtCliente');
    var tabla = $('#tablaArticulos');
    var tipo = $('#tipo');

    initializeTable();
    inicioEtiquetas();

    var btnConfirmar = document.getElementById('btnConfirmar');
    var chkModCantidad = document.getElementById('chkModCantidad');
    //var modCheckbox = document.getElementById('modCheckbox');
    var btnNuevo = document.getElementById('btnNuevo');
    var tableInputs = $('tr input[type="text"]');
    var IndicarCantidad;
    $(chkModCantidad).hide();
    addEvent(chkModCantidad, 'click', modificarCantidades, false);
    //addEvent(modCheckbox, 'click', toggleCheckColumn, false);
    addEvent(btnConfirmar, 'click', realizadoImpresion, false);
    addEvent(btnNuevo, 'click', clearAll, false);
    tabla.on('change', 'tr input[type="text"]', modTextbox);

    // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
    //txtPedido.keypress(function (e) { if (e.which === 13) { clear(); obtenerDatosPedido(); } });
    txtPedido.on("change", function (e) { clear(); obtenerDatosPedido(); });
    txtPedido.focus();

    function initializeTable() {
        var columns = [
            generateColumn('GAART_COD', 'Cod'),
            generateColumn('GAART_DESCRIP', 'Descrip.'),
            generateColumn('txtCant', '<div>Cant. <input type="checkbox" id="chkModCantidad" name="checkbox" /></div>', true, true),
            generateColumn('C_UNI1', '', false),
            generateColumn('MODIF_SN', '', false)
        ];
        var columnDefs = [
            { "targets": 2, "orderable": false },
            { visible: true, targets: [0, 1, 2] },
            { "width": "12em", "targets": 0 },
            //{ "width": "45%", "targets": 1 },
            { "width": "4.2em", "targets": 2 },
        ];
        createTableJson('#tablaArticulos', null, columns, null, null, columnDefs, false);

    }
    var v_cantPredSN;
    function obtenerDatosPedido() {
        var pedido = txtPedido.val();

        var url = "Etiquetas/Pedido";
        var method = "GET";
        var data = {
            empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
            emp_cod: sessionStorage.getItem("EMPR_COD"),
            lecturaPedido: pedido
        };
        var success = function (response) {
            if (response.Ok) {
                v_cantPredSN = response.Objeto.INDICAR_CANTIDAD_PRED_SN;
                var v_cliente = response.Objeto.GGCLIPR_COD;
                var v_articulos = response.Objeto.Lineas.map(function (Obj) {
                    return {
                        GAART_COD: Obj.GAART_COD,
                        GAART_DESCRIP: Obj.GAART_DESCRIP,
                        txtCant: "<input type='text' class='form-control input-sm input-xs' value='" + Obj.C_UNI1 + "' " + (v_cantPredSN == 'S' ? '' : 'disabled') + "/>",
                        C_UNI1: Obj.C_UNI1,
                        MODIF_SN: ''
                    }
                });
                IndicarCantidad = response.Objeto.INDICAR_CANTIDAD_SN == 'S' ? true : false;
                !IndicarCantidad ? $(chkModCantidad).hide() : $(chkModCantidad).show();

                txtCliente.val(v_cliente);
                tabla.DataTable().rows.add(v_articulos).draw();
                //toggleCheckColumn();
                //toggleIndicarCantidad()

            }
        }
        apiGeneral(url, method, data, success);

    }

    /*function toggleIndicarCantidad() {
        tabla.DataTable().columns(3).visible(IndicarCantidad);
    }
    */
    function inicioEtiquetas() {
        var url = "Etiquetas/Inicio";
        var method = "GET";
        var data = {
            empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
            emp_cod: sessionStorage.getItem("EMPR_COD")
        };
        var success = function (response) {
            if (response.Ok) {
                $.each(response.Objeto, function (i, Obj) {
                    tipo.append($('<option>', {
                        value: Obj.PLANTILLA,
                        text: Obj.PLANTILLA
                    }));
                });
            }
        };
        apiGeneral(url, method, data, success);
    }
    function realizadoImpresion() {
        var url = "Etiquetas/Imprime";
        var method = "POST";
        var data = obtenerDatos();
        //var redirectUrl = Router.action('Etiquetas', 'Index');
        var redirectUrl = "Etiquetas/Index";
        var success = function (response) {
            if (response.Ok) {
                clearAll();
                successMessage(response.Mensaje);
            } else {
                lanzarMensajeRedirect(response.Ok, response.Mensaje);
            }
        };
        apiGeneral(url, method, data, success);
    }

    /*function toggleCheckColumn() {
        var v_tabla = tabla.DataTable();
        var mostrar = $(modCheckbox).is(':checked');
        var rows = v_tabla.rows().data();
        rows.map(function (data) {
            var check = data.MODIF_SN = mostrar ? 'S' : 'N';
            data.checkbox = '<input type="checkbox" name="checkbox" ' + (check == 'S' ? 'checked' : '') + '/>';
            data.txtCant = "<input type='text' class='form-control input-sm input-xs' value='" + data.C_UNI1 + "' " + (check == 'S' ? '' : 'disabled') + "/>";
        });
        tabla.DataTable().rows().invalidate(); 
    }
    */

    function obtenerDatos() {
        var data = tabla.DataTable().rows().data();

        var lineas = [];
        data.map(
            function (d) {
                lineas.push({
                    GAART_COD: d.GAART_COD,
                    GAART_DESCRIP: d.GAART_DESCRIP,
                    C_UNI1: d.C_UNI1,
                    MODIF_SN: d.MODIF_SN
                });
            });

        dataImpr = {
            empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
            emp_cod: sessionStorage.getItem("EMPR_COD"),
            lecturaPedido: txtPedido.val(),
            PLANTILLA: tipo.val(),
            Lineas: lineas
        };
        return dataImpr;
    }

    $('tbody').click(function (e) {
        if ($(e.target).is('[type="checkbox"]')) {
            var v_gridLine = $(e.target).closest('tr');

            var v_tabla = tabla.DataTable();
            var checkbox = v_tabla.row(v_gridLine).data().checkbox;
            var textbox = v_tabla.row(v_gridLine).data().txtCant;

            $(textbox).prop('disabled', $(checkbox).is(':checked'));

            v_tabla.row(v_gridLine).data().txtCant = "<input type='text' class='form-control input-sm input-xs' value='" + v_tabla.row(v_gridLine).data().C_UNI1 + "' " + (!$(checkbox).is(':checked') ? '' : 'disabled') + "/>";
            v_tabla.row(v_gridLine).data().checkbox = '<input type="checkbox" name="checkbox" ' + (!$(checkbox).is(':checked') ? 'checked' : '') + '/>';;
            v_tabla.row(v_gridLine).data().MODIF_SN = !$(checkbox).is(':checked') ? 'S' : 'N';
            v_tabla.rows().invalidate();
        }
    });

    function checkedLines() {
        var filas = tabla.find('tbody > tr');
        var nuevasFilas = $.grep(filas, function (element, index) {
            var fila = $(element);
            var celdas = fila.find('td');
            var check = celdas.eq(3).find('input[type="checkbox"]').eq(0);

            return check.is(':checked');
        });
        return nuevasFilas;
    }

    function obtainCheckedData() {
        var v_dataTable = tabla.DataTable();
        var data = [];
        checkedLines().forEach(function (line) {
            data.push(v_dataTable.rows(line._DT_RowIndex).data()[0]);
        });
        return data;
    }

    function modificarCantidades() {
        if (v_cantPredSN === "S") {
            var v_tabla = tabla.DataTable();
            var chbCant = $(chkModCantidad).is(':checked');

            var rows = v_tabla.rows().data();
            rows.map(function (data) {

                data.C_UNI1 = chbCant ? 1 : 0;
                data.txtCant = "<input type='text' class='form-control input-sm input-xs' value='" + data.C_UNI1 + "' />";

            });
            tabla.DataTable().rows().invalidate(); //Borra lo almacenado en caché y actualiza los datos
        }
    }

    function modTextbox() {
        var row = $(this).parentsUntil('tr');
        var value = TryParseInt($(this).val());
        if (value) {
            tabla.DataTable().row(row).data().C_UNI1 = value;
        } else {
            $(this).val(tabla.DataTable().row(row).data().C_UNI1);
        }
    }

    function clear() {
        $('#tipo').val($('#tipo option:first').val());
        tabla.DataTable().rows().clear().draw();
        txtCliente.val("");
        $('input[type="checkbox"]').prop('checked', false);
    }

    function clearAll() {
        clear();
        txtPedido.val("");
        txtPedido.focus();
    }
});