var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
define(["require", "exports", "componentes/api", "componentes/componentes", "componentes/foco", "componentes/pantalla", "componentes/boton", "componentes/campo"], function (require, exports, api_1, componentes_1, foco_1, pantalla_1, boton_1, campo_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.PantallaLogin = void 0;
    class PantallaLogin extends pantalla_1.Pantalla {
        constructor() {
            super();
            this._formLoginForm = document.getElementById('loginForm');
            this.inicializa();
            this.asociaComponentes();
        }
        inicializaComponentes() {
            foco_1.foco.enPrimero(document);
            const vComponentes = {
                _inputUser: (0, campo_1.campo)('User'),
                _inputPassword: (0, campo_1.campo)('Password'),
                _inputDb: (0, campo_1.campo)('db'),
                _inputToken: (0, campo_1.campo)('token'),
                _botonConnect: (0, boton_1.boton)('btnConnect').clic(() => __awaiter(this, void 0, void 0, function* () {
                    this.actualizaModelo();
                    yield this.realizarLogin();
                    this.actualizaVista();
                    this._formLoginForm.submit();
                })),
            };
            return vComponentes;
        }
        asociaComponentes() {
            const vComponentes = this.inicializaComponentes();
            Object.getOwnPropertyNames(vComponentes).forEach(pNombre => this[pNombre] = vComponentes[pNombre].crea());
            this.actualizaVista();
            return;
        }
        inicializa() {
            this._datosPantalla = {
                USER: "",
                PASSWORD: "",
                DB: "",
                TOKEN: "",
            };
        }
        actualizaVista() {
            this._inputUser.valor(this._datosPantalla.USER);
            this._inputPassword.valor(this._datosPantalla.PASSWORD);
            this._inputDb.valor(this._datosPantalla.DB);
            this._inputToken.valor(this._datosPantalla.TOKEN);
        }
        actualizaModelo() {
            this._datosPantalla.USER = this._inputUser.valor();
            this._datosPantalla.PASSWORD = this._inputPassword.valor();
            this._datosPantalla.DB = this._inputDb.valor();
            this._datosPantalla.TOKEN = this._inputToken.valor();
        }
        realizarLogin() {
            return __awaiter(this, void 0, void 0, function* () {
                let vResultado;
                try {
                    let parametro;
                    parametro = "=" + this._datosPantalla.USER + "/" + this._datosPantalla.PASSWORD + "@" + this._datosPantalla.DB;
                    [vResultado] = yield (0, api_1.api)('/login')
                        .metodo('post')
                        .parametros(parametro)
                        .invoca();
                    if ([vResultado]) {
                        sessionStorage.setItem("user", this._datosPantalla.USER);
                        sessionStorage.setItem("pass", this._datosPantalla.PASSWORD);
                        sessionStorage.setItem("db", this._datosPantalla.DB);
                        localStorage.setItem("token", vResultado);
                        this._datosPantalla.TOKEN = vResultado;
                    }
                }
                catch ([vMensaje]) {
                    yield (0, componentes_1.mensaje)().error().muestra(vMensaje);
                    foco_1.foco.en(this._inputUser);
                    return;
                }
                return vResultado;
            });
        }
    }
    exports.PantallaLogin = PantallaLogin;
});
