var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
define(["require", "exports", "componentes/boton", "componentes/campo", "componentes/bloque", "Movimientos/Shared/modelos/DatosAlmacen", "componentes/api", "componentes/mensaje", "utilidades/assert", "componentes/lov", "componentes/foco"], function (require, exports, boton_1, campo_1, bloque_1, DatosAlmacen_1, api_1, mensaje_1, assert, lov_1, foco_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.BloqueDestino = void 0;
    class BloqueDestino {
        constructor(Padre) {
            this._datosDestino = new DatosAlmacen_1.DatosAlmacen();
            const vComponentes = this.inicializaComponentes();
            Object.getOwnPropertyNames(vComponentes).forEach(pNombre => this[pNombre] = vComponentes[pNombre].crea());
            this._PantallaPadre = Padre;
        }
        get Datos() {
            return this._datosDestino;
        }
        set Datos(value) {
            this._datosDestino = value;
            this.actualizaBloque();
        }
        inicializaComponentes() {
            const vComponentes = {
                _botonConsulta: (0, boton_1.boton)('btnDestinoConsulta')
                    .clic(() => __awaiter(this, void 0, void 0, function* () {
                    const vUbicacionSeleccionada = yield this.ConsultaDatos();
                    if (!vUbicacionSeleccionada && (this._datosDestino.ControlLotes || this._datosDestino.ControlUbicaciones))
                        if (!this._datosDestino.Almacen)
                            foco_1.foco.en(this._inputAlmacen);
                        else
                            foco_1.foco.enSiguienteA(this._inputAlmacen);
                    else
                        foco_1.foco.enSiguienteA(this._inputLote);
                })),
                _inputAlmacen: (0, campo_1.campo)('txtDestinoAlmacen')
                    .cambio((valor) => __awaiter(this, void 0, void 0, function* () {
                    this.Almacen = valor;
                    let AlmacenValido = yield this.ValidarAlmacen();
                    if (!AlmacenValido) {
                        foco_1.foco.en(this._inputAlmacen);
                    }
                    else {
                        foco_1.foco.enSiguienteA(this._inputAlmacen);
                        yield this.GestionaUbicacionDefecto();
                    }
                    this.actualizaVista();
                })),
                _botonConsultaAlmacen: (0, boton_1.boton)('btnDestinoAlmacen').clic(() => __awaiter(this, void 0, void 0, function* () {
                    const AlmacenSeleccionado = yield this.ConsultaAlmacen();
                    if (AlmacenSeleccionado)
                        foco_1.foco.enSiguienteA(this._inputAlmacen);
                    else
                        foco_1.foco.en(this._inputAlmacen);
                })),
                _botonConsultaUbicacion: (0, boton_1.boton)('btnDestinoUbicacion').clic(() => __awaiter(this, void 0, void 0, function* () {
                    const vSeleccionado = yield this.ConsultaUbicaciones();
                    if (vSeleccionado)
                        foco_1.foco.enSiguienteA(this._inputUbicacion);
                    else
                        foco_1.foco.en(this._inputUbicacion);
                })),
                _bloqueDestinoUbicacion: (0, bloque_1.bloque)('bloqueDestinoUbicacion'),
                _bloqueDestinoLote: (0, bloque_1.bloque)('bloqueDestinoLote'),
                _inputUbicacion: (0, campo_1.campo)('txtDestinoUbicacion')
                    .cambio(() => __awaiter(this, void 0, void 0, function* () {
                    this.actualizaModelo();
                    yield this.ValidarUbicacion();
                    this.actualizaVista();
                })),
                _inputLote: (0, campo_1.campo)('txtDestinoLote')
                    .cambio(() => {
                    this.actualizaModelo();
                    this.actualizaVista();
                })
            };
            return vComponentes;
        }
        Inicializa() {
            this.Articulo = null;
            this.actualizaBloque();
        }
        set Articulo(value) {
            this._datosDestino = new DatosAlmacen_1.DatosAlmacen({ Articulo: value, Almacen: this._datosDestino.AlmacenDefecto, AlmacenDefecto: this._datosDestino.AlmacenDefecto });
            this._datosDestino.Articulo = value;
        }
        set Almacen(value) {
            this._datosDestino.Almacen = value;
            this._datosDestino.Ubicacion = null;
            this._datosDestino.Lote = null;
        }
        set ControlLotes(Lotes) {
            this._datosDestino.ControlLotes = Lotes === 'S';
            this._bloqueDestinoUbicacion.clase('l2', !this._datosDestino.ControlLotes);
        }
        set ControlUbicaciones(Ubicaciones) {
            this._datosDestino.ControlUbicaciones = Ubicaciones === 'S';
            this._bloqueDestinoLote.clase('l2', !this._datosDestino.ControlUbicaciones);
        }
        actualizaVista() {
            this.actualizaBloque();
            this._PantallaPadre.actualizaModelo();
            this._PantallaPadre.actualizaVista();
        }
        actualizaBloque() {
            this._inputAlmacen.valor(this._datosDestino.Almacen);
            if (this._datosDestino.ControlUbicaciones) {
                this.ControlUbicaciones = 'S';
                this._inputUbicacion.valor(this._datosDestino.Ubicacion);
                this._bloqueDestinoUbicacion.visible(true);
            }
            else {
                this.ControlUbicaciones = 'N';
                this._bloqueDestinoUbicacion.visible(false);
            }
            if (this._datosDestino.ControlLotes) {
                this.ControlLotes = 'S';
                this._inputLote.valor(this._datosDestino.Lote);
                this._bloqueDestinoLote.visible(true);
            }
            else {
                this.ControlLotes = 'N';
                this._bloqueDestinoLote.visible(false);
            }
            this._inputLote.valor(this._datosDestino.Lote);
            if (this._datosDestino.Articulo)
                this.HabilitarCampos();
            else
                this.DeshabilitarCampos();
        }
        DeshabilitarCampos() {
            this._botonConsulta.deshabilita();
            this._botonConsultaAlmacen.deshabilita();
            this._botonConsultaUbicacion.deshabilita();
            this._inputAlmacen.deshabilita();
            this._inputUbicacion.deshabilita();
            this._inputLote.deshabilita();
        }
        HabilitarCampos() {
            this._botonConsulta.habilita();
            this._botonConsultaAlmacen.habilita();
            this._botonConsultaUbicacion.habilita();
            this._inputAlmacen.habilita();
            this._inputUbicacion.habilita();
            this._inputLote.habilita();
        }
        actualizaModelo() {
            this._datosDestino.Almacen = this._inputAlmacen.valor();
            this._datosDestino.Ubicacion = this._inputUbicacion.valor();
            this._datosDestino.Lote = this._inputLote.valor();
        }
        ValidarUbicacionLote() {
            return __awaiter(this, void 0, void 0, function* () {
                const LotesDisponibles = yield this.ObtenerLotesArticuloAlmacen();
                const UbicacionLoteValido = LotesDisponibles.some(pLote => (!this._datosDestino.Ubicacion || pLote.GAUBIC_COD === this._datosDestino.Ubicacion) &&
                    (!this._datosDestino.Lote || pLote.LOTE === this._datosDestino.Lote));
                return UbicacionLoteValido;
            });
        }
        ConsultaDatos() {
            return __awaiter(this, void 0, void 0, function* () {
                try {
                    const valor = yield this.ObtenerLotesArticuloAlmacen();
                    const vColumnas = [
                        { propiedad: 'C_UNID1', titulo: Resources.PantallaMovimientos.ConsultaUbicacionLote.Tabla.Disponible }
                    ];
                    if (this._datosDestino.ControlLotes)
                        vColumnas.unshift({ propiedad: 'LOTE', titulo: Resources.PantallaMovimientos.ConsultaUbicacionLote.Tabla.Lote });
                    if (this._datosDestino.ControlUbicaciones)
                        vColumnas.unshift({ propiedad: 'GAUBIC_COD', titulo: Resources.PantallaMovimientos.ConsultaUbicacionLote.Tabla.Ubicacion, ancho: '6em' });
                    let vElegido = yield (0, lov_1.lov)()
                        .titulo(Resources.PantallaMovimientos.ConsultaUbicacionLote.Destino.Titulo)
                        .columnas(vColumnas)
                        .elige(valor);
                    if (typeof vElegido !== 'undefined') {
                        this._datosDestino.Ubicacion = vElegido.GAUBIC_COD;
                        this._datosDestino.Lote = vElegido.LOTE;
                        this.actualizaVista();
                        return true;
                    }
                }
                catch ([vMensajeError]) {
                    yield (0, mensaje_1.mensaje)().error().muestra(vMensajeError);
                }
                return false;
            });
        }
        ObtenerLotesArticuloAlmacen() {
            return __awaiter(this, void 0, void 0, function* () {
                let valor = null;
                [valor] = yield (0, api_1.api)("/Movimientos/LotesArticuloAlmacen")
                    .metodo('get')
                    .parametros({
                    "empgrupo_cod": this._datosDestino.Grupo,
                    "emp_cod": this._datosDestino.Empresa,
                    "gaalmnom_cod": this._datosDestino.Almacen,
                    "gaart_cod": this._datosDestino.Articulo,
                    "opcion": 'DESTINO'
                })
                    .invoca();
                return valor;
            });
        }
        ValidarUbicacion() {
            return __awaiter(this, void 0, void 0, function* () {
                let valor = null;
                try {
                    [valor] = yield (0, api_1.api)("/Inventario/Ubicacion")
                        .metodo('get')
                        .parametros({
                        "empgrupo_cod": this._datosDestino.Grupo,
                        "emp_cod": this._datosDestino.Empresa,
                        "gaart_cod": this._datosDestino.Articulo,
                        "gaalmnom_cod": this._datosDestino.Almacen,
                        "gaubic_cod": this._datosDestino.Ubicacion,
                        "lote": this._datosDestino.Lote
                    })
                        .invoca();
                }
                catch ([vMensajeError]) {
                    yield (0, mensaje_1.mensaje)().error().muestra(vMensajeError);
                }
                if (valor)
                    return true;
                return false;
            });
        }
        ValidarAlmacen() {
            return __awaiter(this, void 0, void 0, function* () {
                const vAlmacenes = yield this.ObtenerAlmacenesActivos();
                const AlmacenValido = vAlmacenes.some(pAlmacen => pAlmacen.COD === this._inputAlmacen.valor());
                if (!AlmacenValido) {
                    yield (0, mensaje_1.mensaje)().error().muestra(Resources.PantallaMovimientos.Error.Almacen_no_valido);
                    this.Almacen = null;
                }
                return AlmacenValido;
            });
        }
        ObtenerAlmacenesActivos() {
            return __awaiter(this, void 0, void 0, function* () {
                let vAlmacenes;
                try {
                    [vAlmacenes] = yield (0, api_1.api)('/Movimientos/AlmacenesActivos')
                        .parametros({
                        empgrupo_cod: this.Datos.Grupo,
                        emp_cod: this.Datos.Empresa,
                        gaart_cod: this.Datos.Articulo,
                        opcion: "A"
                    })
                        .invoca();
                }
                catch ([vMensaje]) {
                    yield (0, mensaje_1.mensaje)().error().muestra(vMensaje);
                    return;
                }
                assert.esUnArrayDe(vAlmacenes, 'COD', 'DESCRIP');
                return vAlmacenes;
            });
        }
        ConsultaAlmacen() {
            return __awaiter(this, void 0, void 0, function* () {
                const vAlmacenes = yield this.ObtenerAlmacenesActivos();
                let vElegido = yield (0, lov_1.lov)()
                    .titulo(Resources.PantallaMovimientos.ConsultaAlmacen.Destino.Titulo)
                    .columnas([
                    { propiedad: 'COD', titulo: Resources.PantallaMovimientos.ConsultaAlmacen.Tabla.Codigo, ancho: '6em' },
                    { propiedad: 'DESCRIP', titulo: Resources.PantallaMovimientos.ConsultaAlmacen.Tabla.Descripcion }
                ])
                    .elige(vAlmacenes);
                if (typeof vElegido !== 'undefined') {
                    this.Almacen = vElegido.COD;
                    yield this.GestionaUbicacionDefecto();
                    this.actualizaVista();
                    return true;
                }
                return false;
            });
        }
        GestionaUbicacionDefecto() {
            return __awaiter(this, void 0, void 0, function* () {
                const vUbicacionOrigen = yield this.UbicacionDefecto();
                this._datosDestino.Ubicacion = vUbicacionOrigen.GAUBIC_DEF;
                if (this._datosDestino.Ubicacion)
                    foco_1.foco.enSiguienteA(this._inputUbicacion);
            });
        }
        ObtenerUbicaciones() {
            return __awaiter(this, void 0, void 0, function* () {
                let vUbicaciones;
                try {
                    [vUbicaciones] = yield (0, api_1.api)('/Movimientos/Ubicaciones')
                        .parametros({
                        empgrupo_cod: this.Datos.Grupo,
                        emp_cod: this.Datos.Empresa,
                        gaalmnom_cod: this.Datos.Almacen,
                        ori_des: "DES"
                    })
                        .invoca();
                }
                catch ([vMensaje]) {
                    yield (0, mensaje_1.mensaje)().error().muestra(vMensaje);
                    return;
                }
                assert.esUnArrayDe(vUbicaciones, 'COD');
                return vUbicaciones;
            });
        }
        ConsultaUbicaciones() {
            return __awaiter(this, void 0, void 0, function* () {
                let vUbicaciones = yield this.ObtenerUbicaciones();
                let vElegido = yield (0, lov_1.lov)()
                    .titulo(Resources.PantallaMovimientos.ConsultaAlmacen.Destino.Titulo)
                    .columnas([
                    { propiedad: 'COD', titulo: Resources.PantallaMovimientos.ConsultaUbicacionLote.Tabla.Ubicacion, ancho: '6em' }
                ])
                    .elige(vUbicaciones);
                if (typeof vElegido !== 'undefined') {
                    this._datosDestino.Ubicacion = vElegido.COD;
                    this.actualizaVista();
                    return true;
                }
                return false;
            });
        }
        UbicacionDefecto() {
            return __awaiter(this, void 0, void 0, function* () {
                if (!this.Datos.Almacen)
                    return { GAUBIC_DEF: null };
                let item;
                try {
                    [item] = yield (0, api_1.api)("/Movimientos/UbicDefArticulo")
                        .metodo('get')
                        .parametros({
                        empgrupo_cod: this.Datos.Grupo,
                        emp_cod: this.Datos.Empresa,
                        gaart_cod: this._datosDestino.Articulo,
                        gaalmnom_cod: this._datosDestino.Almacen
                    })
                        .invoca();
                }
                catch ([v_mensaje]) {
                    yield (0, mensaje_1.mensaje)().error().muestra(v_mensaje);
                    return;
                }
                assert.esUn(item, "GAUBIC_DEF");
                return item;
            });
        }
    }
    exports.BloqueDestino = BloqueDestino;
});
