var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
define(["require", "exports", "componentes/boton", "componentes/campo", "componentes/bloque", "Movimientos/Shared/modelos/DatosAlmacen", "componentes/api", "componentes/mensaje", "utilidades/assert", "componentes/lov", "componentes/foco"], function (require, exports, boton_1, campo_1, bloque_1, DatosAlmacen_1, api_1, mensaje_1, assert, lov_1, foco_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.BloqueOrigen = void 0;
    class BloqueOrigen {
        constructor(Padre) {
            this._datosOrigen = new DatosAlmacen_1.DatosAlmacen();
            const vComponentes = this.inicializaComponentes();
            Object.getOwnPropertyNames(vComponentes).forEach(pNombre => this[pNombre] = vComponentes[pNombre].crea());
            this._PantallaPadre = Padre;
        }
        onUpdateCallBack(fn) {
            fn();
        }
        get Datos() {
            return this._datosOrigen;
        }
        set Datos(value) {
            this._datosOrigen = value;
            this.actualizaBloque();
        }
        inicializaComponentes() {
            const vComponentes = {
                _botonConsulta: (0, boton_1.boton)('btnOrigenConsulta')
                    .clic(() => __awaiter(this, void 0, void 0, function* () {
                    const vUbicacionSeleccionada = yield this.ConsultaDatos();
                    if (!vUbicacionSeleccionada && (this._datosOrigen.ControlLotes || this._datosOrigen.ControlUbicaciones))
                        if (!this._datosOrigen.Almacen)
                            foco_1.foco.en(this._inputAlmacen);
                        else
                            foco_1.foco.enSiguienteA(this._inputAlmacen);
                    else
                        foco_1.foco.enSiguienteA(this._inputLote);
                })),
                _inputAlmacen: (0, campo_1.campo)('txtOrigenAlmacen')
                    .cambio((valor) => __awaiter(this, void 0, void 0, function* () {
                    this.Almacen = valor;
                    const AlmacenValido = yield this.ValidarAlmacen();
                    if (!AlmacenValido) {
                        foco_1.foco.en(this._inputAlmacen);
                    }
                    else {
                        foco_1.foco.enSiguienteA(this._inputAlmacen);
                        yield this.GestionaUbicacionDefecto();
                    }
                    this.actualizaVista();
                })),
                _botonConsultaAlmacen: (0, boton_1.boton)('btnOrigenAlmacen').clic(() => __awaiter(this, void 0, void 0, function* () {
                    const AlmacenSeleccionado = yield this.ConsultaAlmacen();
                    if (AlmacenSeleccionado)
                        foco_1.foco.enSiguienteA(this._inputAlmacen);
                    else
                        foco_1.foco.en(this._inputAlmacen);
                })),
                _bloqueOrigenUbicacion: (0, bloque_1.bloque)('bloqueOrigenUbicacion'),
                _bloqueOrigenLote: (0, bloque_1.bloque)('bloqueOrigenLote'),
                _inputUbicacion: (0, campo_1.campo)('txtOrigenUbicacion')
                    .cambio(() => __awaiter(this, void 0, void 0, function* () {
                    this.actualizaModelo();
                    const vUbicacionValida = yield this.ValidarUbicacionLote();
                    if (!vUbicacionValida) {
                        yield (0, mensaje_1.mensaje)().error().muestra("No es una ubicación válida.");
                        foco_1.foco.en(this._inputUbicacion);
                        this.Datos.Ubicacion = null;
                    }
                    this.actualizaVista();
                })),
                _inputLote: (0, campo_1.campo)('txtOrigenLote')
                    .cambio(() => __awaiter(this, void 0, void 0, function* () {
                    this.actualizaModelo();
                    const vLoteValido = yield this.ValidarUbicacionLote();
                    if (!vLoteValido) {
                        if (this._datosOrigen.ControlUbicaciones) {
                            yield (0, mensaje_1.mensaje)().error().muestra("El lote/ubicación indicados no están activos.");
                            foco_1.foco.en(this._inputUbicacion);
                        }
                        else {
                            yield (0, mensaje_1.mensaje)().error().muestra("No es un lote válido.");
                            foco_1.foco.en(this._inputLote);
                        }
                        this.Datos.Lote = null;
                    }
                    this.actualizaVista();
                }))
            };
            return vComponentes;
        }
        Inicializa() {
            this.Articulo = null;
            this.actualizaBloque();
        }
        set Articulo(value) {
            this._datosOrigen = new DatosAlmacen_1.DatosAlmacen({ Articulo: value, Almacen: this._datosOrigen.AlmacenDefecto, AlmacenDefecto: this._datosOrigen.AlmacenDefecto });
            this._datosOrigen.Articulo = value;
        }
        set Almacen(value) {
            this._datosOrigen.Almacen = value;
            this._datosOrigen.Ubicacion = null;
            this._datosOrigen.Lote = null;
        }
        set ControlLotes(Lotes) {
            this._datosOrigen.ControlLotes = Lotes === 'S';
            this._bloqueOrigenUbicacion.clase('l2', !this._datosOrigen.ControlLotes);
        }
        set ControlUbicaciones(Ubicaciones) {
            this._datosOrigen.ControlUbicaciones = Ubicaciones === 'S';
            this._bloqueOrigenLote.clase('l2', !this._datosOrigen.ControlUbicaciones);
        }
        actualizaVista() {
            this.actualizaBloque();
            this._PantallaPadre.actualizaModelo();
            this._PantallaPadre.actualizaVista();
        }
        actualizaBloque() {
            this._inputAlmacen.valor(this._datosOrigen.Almacen);
            if (this._datosOrigen.ControlUbicaciones) {
                this.ControlUbicaciones = 'S';
                this._inputUbicacion.valor(this._datosOrigen.Ubicacion);
                this._bloqueOrigenUbicacion.visible(true);
            }
            else {
                this.ControlUbicaciones = 'N';
                this._bloqueOrigenUbicacion.visible(false);
            }
            if (this._datosOrigen.ControlLotes) {
                this.ControlLotes = 'S';
                this._inputLote.valor(this._datosOrigen.Lote);
                this._bloqueOrigenLote.visible(true);
            }
            else {
                this.ControlLotes = 'N';
                this._bloqueOrigenLote.visible(false);
            }
            this._inputLote.valor(this._datosOrigen.Lote);
            if (this._datosOrigen.Articulo)
                this.HabilitarCampos();
            else
                this.DeshabilitarCampos();
        }
        DeshabilitarCampos() {
            this._botonConsulta.deshabilita();
            this._botonConsultaAlmacen.deshabilita();
            this._inputAlmacen.deshabilita();
            this._inputUbicacion.deshabilita();
            this._inputLote.deshabilita();
        }
        HabilitarCampos() {
            this._botonConsulta.habilita();
            this._botonConsultaAlmacen.habilita();
            this._inputAlmacen.habilita();
            this._inputUbicacion.habilita();
            this._inputLote.habilita();
        }
        actualizaModelo() {
            this._datosOrigen.Almacen = this._inputAlmacen.valor();
            this._datosOrigen.Ubicacion = this._inputUbicacion.valor();
            this._datosOrigen.Lote = this._inputLote.valor();
        }
        ValidarUbicacionLote() {
            return __awaiter(this, void 0, void 0, function* () {
                const LotesDisponibles = yield this.ObtenerLotesArticuloAlmacen();
                const UbicacionLoteValido = LotesDisponibles.some(pLote => (!this._datosOrigen.Ubicacion || pLote.GAUBIC_COD === this._datosOrigen.Ubicacion) &&
                    (!this._datosOrigen.Lote || pLote.LOTE === this._datosOrigen.Lote));
                return UbicacionLoteValido;
            });
        }
        ConsultaDatos() {
            return __awaiter(this, void 0, void 0, function* () {
                try {
                    const valor = yield this.ObtenerLotesArticuloAlmacen();
                    const vColumnas = [
                        { propiedad: 'C_UNID1', titulo: Resources.PantallaMovimientos.ConsultaUbicacionLote.Tabla.Disponible }
                    ];
                    if (this._datosOrigen.ControlLotes)
                        vColumnas.unshift({ propiedad: 'LOTE', titulo: Resources.PantallaMovimientos.ConsultaUbicacionLote.Tabla.Lote });
                    if (this._datosOrigen.ControlUbicaciones)
                        vColumnas.unshift({ propiedad: 'GAUBIC_COD', titulo: Resources.PantallaMovimientos.ConsultaUbicacionLote.Tabla.Ubicacion, ancho: '6em' });
                    let vElegido = yield (0, lov_1.lov)()
                        .titulo(Resources.PantallaMovimientos.ConsultaUbicacionLote.Origen.Titulo)
                        .columnas(vColumnas)
                        .elige(valor);
                    if (typeof vElegido !== 'undefined') {
                        this._datosOrigen.Ubicacion = vElegido.GAUBIC_COD;
                        this._datosOrigen.Lote = vElegido.LOTE;
                        this.actualizaVista();
                        return true;
                    }
                }
                catch ([vMensajeError]) {
                    yield (0, mensaje_1.mensaje)().error().muestra(vMensajeError);
                }
                return false;
            });
        }
        ObtenerLotesArticuloAlmacen() {
            return __awaiter(this, void 0, void 0, function* () {
                let valor = null;
                [valor] = yield (0, api_1.api)("/Movimientos/LotesArticuloAlmacen")
                    .metodo('get')
                    .parametros({
                    empgrupo_cod: this._datosOrigen.Grupo,
                    emp_cod: this._datosOrigen.Empresa,
                    gaalmnom_cod: this._datosOrigen.Almacen,
                    gaart_cod: this._datosOrigen.Articulo,
                    opcion: 'ORIGEN'
                })
                    .invoca();
                return valor;
            });
        }
        ValidarUbicacion() {
            return __awaiter(this, void 0, void 0, function* () {
                let valor = null;
                try {
                    [valor] = yield (0, api_1.api)("/Inventario/Ubicacion")
                        .metodo('get')
                        .parametros({
                        "empgrupo_cod": this._datosOrigen.Grupo,
                        "emp_cod": this._datosOrigen.Empresa,
                        "gaart_cod": this._datosOrigen.Articulo,
                        "gaalmnom_cod": this._datosOrigen.Almacen,
                        "gaubic_cod": this._datosOrigen.Ubicacion,
                        "lote": this._datosOrigen.Lote
                    })
                        .invoca();
                }
                catch ([vMensajeError]) {
                    yield (0, mensaje_1.mensaje)().error().muestra(vMensajeError);
                }
                if (valor)
                    return true;
                return false;
            });
        }
        ValidarAlmacen() {
            return __awaiter(this, void 0, void 0, function* () {
                const vAlmacenes = yield this.ObtenerAlmacenesActivos();
                const AlmacenValido = vAlmacenes.some(pAlmacen => pAlmacen.COD === this._inputAlmacen.valor());
                if (!AlmacenValido) {
                    yield (0, mensaje_1.mensaje)().error().muestra(Resources.PantallaMovimientos.Error.Almacen_no_valido);
                    this.Almacen = null;
                }
                return AlmacenValido;
            });
        }
        ObtenerAlmacenesActivos() {
            return __awaiter(this, void 0, void 0, function* () {
                let vAlmacenes;
                try {
                    [vAlmacenes] = yield (0, api_1.api)('/Movimientos/AlmacenesActivos')
                        .parametros({
                        empgrupo_cod: this.Datos.Grupo,
                        emp_cod: this.Datos.Empresa,
                        gaart_cod: this.Datos.Articulo,
                        opcion: "P"
                    })
                        .invoca();
                }
                catch ([vMensaje]) {
                    yield (0, mensaje_1.mensaje)().error().muestra(vMensaje);
                    return;
                }
                assert.esUnArrayDe(vAlmacenes, 'COD', 'DESCRIP');
                return vAlmacenes;
            });
        }
        ConsultaAlmacen() {
            return __awaiter(this, void 0, void 0, function* () {
                const vAlmacenes = yield this.ObtenerAlmacenesActivos();
                let vElegido = yield (0, lov_1.lov)()
                    .titulo(Resources.PantallaMovimientos.ConsultaAlmacen.Origen.Titulo)
                    .columnas([
                    { propiedad: 'COD', titulo: Resources.PantallaMovimientos.ConsultaAlmacen.Tabla.Codigo, ancho: '6em' },
                    { propiedad: 'DESCRIP', titulo: Resources.PantallaMovimientos.ConsultaAlmacen.Tabla.Descripcion }
                ])
                    .elige(vAlmacenes);
                if (typeof vElegido !== 'undefined') {
                    this.Almacen = vElegido.COD;
                    yield this.GestionaUbicacionDefecto();
                    this.actualizaVista();
                    return true;
                }
                return false;
            });
        }
        GestionaUbicacionDefecto() {
            return __awaiter(this, void 0, void 0, function* () {
                const vUbicacionOrigen = yield this.UbicacionDefecto();
                this._datosOrigen.Ubicacion = vUbicacionOrigen.GAUBIC_DEF;
                if (this._datosOrigen.Ubicacion) {
                    const vUbicacionValida = yield this.ValidarUbicacionLote();
                    if (!vUbicacionValida) {
                        this._datosOrigen.Ubicacion = null;
                        foco_1.foco.en(this._inputUbicacion);
                    }
                    else {
                        foco_1.foco.enSiguienteA(this._inputUbicacion);
                    }
                }
            });
        }
        UbicacionDefecto() {
            return __awaiter(this, void 0, void 0, function* () {
                if (!this.Datos.Almacen)
                    return { GAUBIC_DEF: null };
                let item;
                try {
                    [item] = yield (0, api_1.api)("/Movimientos/UbicDefArticulo")
                        .metodo('get')
                        .parametros({
                        empgrupo_cod: this.Datos.Grupo,
                        emp_cod: this.Datos.Empresa,
                        gaart_cod: this._datosOrigen.Articulo,
                        gaalmnom_cod: this._datosOrigen.Almacen
                    })
                        .invoca();
                }
                catch ([v_mensaje]) {
                    yield (0, mensaje_1.mensaje)().error().muestra(v_mensaje);
                    return;
                }
                assert.esUn(item, "GAUBIC_DEF");
                return item;
            });
        }
    }
    exports.BloqueOrigen = BloqueOrigen;
});
