var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
define(["require", "exports", "componentes/boton", "componentes/campo", "Movimientos/Shared/_BloqueDestino", "Movimientos/modelos/entradas", "componentes/mensaje", "componentes/pantalla", "componentes/foco", "componentes/api", "utilidades/assert", "componentes/notificacion", "Movimientos/Shared/modelos/DatosAlmacen", "componentes/lov"], function (require, exports, boton_1, campo_1, _BloqueDestino_1, entradas_1, mensaje_1, pantalla_1, foco_1, api_1, assert, notificacion_1, DatosAlmacen_1, lov_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.PantallaEntradas = void 0;
    class PantallaEntradas extends pantalla_1.Pantalla {
        constructor() {
            super();
            this._model = new entradas_1.EntradasModel();
            const vComponentes = this.inicializaComponentes();
            Object.getOwnPropertyNames(vComponentes).forEach(pNombre => this[pNombre] = vComponentes[pNombre].crea());
            this._bloqueDestino = new _BloqueDestino_1.BloqueDestino(this);
            this._bloqueDestino.actualizaBloque();
            this._model.DatosDestino = this._bloqueDestino.Datos;
            this.ObtenerDatosEntradas().then(vTiposMovimiento => {
                if (vTiposMovimiento) {
                    this._model.TipoMovimiento = vTiposMovimiento.GAMOVTIP[0];
                    this._model.DatosDestino.AlmacenDefecto = vTiposMovimiento.GAALMNOM_DES;
                }
            });
            this.actualizaVista();
        }
        inicializaComponentes() {
            const vComponentes = {
                _botonNuevo: (0, boton_1.boton)('btnNuevo').clic(() => { this.Inicializa(); }),
                _botonGuardar: (0, boton_1.boton)('btnGuardar').clic(() => __awaiter(this, void 0, void 0, function* () {
                    const resultado = yield this.Confirmar();
                    if (resultado)
                        this.Inicializa();
                    this.actualizaVista();
                })),
                _inputArticulo: (0, campo_1.campo)('txtArticulo').cambio((pValor) => __awaiter(this, void 0, void 0, function* () {
                    yield this.CambioArticulo(pValor);
                    foco_1.foco.enSiguienteA(this._inputArticulo);
                    if (this._bloqueDestino.Datos.Almacen)
                        foco_1.foco.enSiguienteA(this._bloqueDestino._inputAlmacen);
                    if (this._bloqueDestino.Datos.Ubicacion)
                        foco_1.foco.enSiguienteA(this._bloqueDestino._inputUbicacion);
                })),
                _inputArticuloDescipcion: (0, campo_1.campo)('txtArticuloDescrip'),
                _inputCantidad: (0, campo_1.campo)('txtCantidad').valida(() => {
                    this.CambioCantidad();
                })
            };
            return vComponentes;
        }
        Inicializa() {
            this._model = new entradas_1.EntradasModel({
                TipoMovimiento: this._model.TipoMovimiento,
                DatosDestino: new DatosAlmacen_1.DatosAlmacen({
                    AlmacenDefecto: this._model.DatosDestino.AlmacenDefecto
                })
            });
            this._bloqueDestino.Inicializa();
            this.actualizaVista();
            foco_1.foco.en(this._inputArticulo);
        }
        actualizaVista() {
            this._inputArticulo.valor(this._model.Articulo);
            this._inputArticuloDescipcion.valor(this._model.ArticuloDescripcion);
            this._inputCantidad.valor(this._model.Cantidad);
            this._bloqueDestino.Datos = this._model.DatosDestino;
            this._bloqueDestino.actualizaBloque();
            if (this._model.Articulo)
                this._inputCantidad.habilita();
            else
                this._inputCantidad.deshabilita();
            this._botonGuardar.habilitado(this._model.ModeloValido);
        }
        actualizaModelo() {
            this._model.Articulo = this._inputArticulo.valor();
            if (this._bloqueDestino)
                this._model.DatosDestino = this._bloqueDestino.Datos;
            this._model.Cantidad = this._inputCantidad.valor();
        }
        CambioArticulo(Articulo) {
            return __awaiter(this, void 0, void 0, function* () {
                this._model = new entradas_1.EntradasModel({ TipoMovimiento: this._model.TipoMovimiento });
                const vArticulo = yield this.BuscarCodigosAlternativos(Articulo);
                const resultado = yield this.ValidarArticulo(vArticulo);
                if (resultado) {
                    this._model.Articulo = resultado.GAART_COD;
                    this._model.ArticuloDescripcion = resultado.DESCRIP;
                    this._bloqueDestino.Articulo = resultado.GAART_COD;
                    this._bloqueDestino.ControlUbicaciones = resultado.UBIC_SN;
                    this._bloqueDestino.ControlLotes = resultado.LOTES_SN;
                    if (this._bloqueDestino.Datos.AlmacenDefecto) {
                        this._bloqueDestino.Datos.Ubicacion = (yield this._bloqueDestino.UbicacionDefecto()).GAUBIC_DEF;
                    }
                    this._model.DatosDestino = this._bloqueDestino.Datos;
                }
                this.actualizaVista();
            });
        }
        ValidarArticulo(Articulo) {
            return __awaiter(this, void 0, void 0, function* () {
                let item;
                try {
                    [item] = yield (0, api_1.api)("/Movimientos/ArticuloCompleto")
                        .metodo('get')
                        .parametros({
                        empgrupo_cod: this._model.Grupo,
                        emp_cod: this._model.Empresa,
                        lecturaarticulo: Articulo,
                    })
                        .invoca();
                }
                catch ([v_mensaje]) {
                    yield (0, mensaje_1.mensaje)().error().muestra(v_mensaje);
                    return;
                }
                assert.esUn(item, "GAART_COD", "DESCRIP");
                return item;
            });
        }
        CambioCantidad() {
            this.actualizaModelo();
            if (!this._model.DatosDestino.ModeloValido) {
                (0, mensaje_1.mensaje)().muestra(Resources.PantallaMovimientos.Error.Datos_Faltantes);
                this._inputCantidad.valor(null);
                foco_1.foco.en(this._inputCantidad);
                this.actualizaVista();
            }
            else {
                this.actualizaVista();
                foco_1.foco.en(this._botonGuardar);
            }
        }
        ObtenerDatosEntradas() {
            return __awaiter(this, void 0, void 0, function* () {
                let DatosEntradas;
                [DatosEntradas] = yield (0, api_1.api)("RF_Movimientos/InicioEntradas")
                    .parametros({
                    "empgrupo_cod": this._model.Grupo,
                    "emp_cod": this._model.Empresa,
                })
                    .invoca();
                assert.esUn(DatosEntradas, "GAMOVTIP");
                return DatosEntradas;
            });
        }
        Confirmar() {
            return __awaiter(this, void 0, void 0, function* () {
                this.actualizaModelo();
                if (this._model.ModeloValido) {
                    try {
                        let vObjeto;
                        let vMensaje;
                        console.log("Modelo >>> " + JSON.stringify(this._model));
                        [vObjeto, vMensaje] = yield (0, api_1.api)('/Movimientos/DarEntrada')
                            .metodo('put')
                            .parametros({
                            "EMPGRUPO_COD": this._model.Grupo,
                            "EMP_COD": this._model.Empresa,
                            "GAMOVTIP_COD": this._model.TipoMovimiento.COD,
                            "GAART_COD": this._model.Articulo,
                            "GAALMNOM_COD": this._model.DatosDestino.Almacen,
                            "GAUBIC_COD": this._model.DatosDestino.Ubicacion,
                            "LOTE": this._model.DatosDestino.Lote,
                            "C_UNID1": this._model.Cantidad,
                            "C_UNID2": 0
                        })
                            .invoca();
                        (0, notificacion_1.notificacion)().muestra(vMensaje);
                        return true;
                    }
                    catch ([vMensajeError]) {
                        yield (0, mensaje_1.mensaje)().error().muestra(vMensajeError);
                    }
                }
                else {
                    yield (0, mensaje_1.mensaje)().error().muestra(Resources.PantallaMovimientos.Error.Datos_Faltantes);
                }
                return false;
            });
        }
        BuscarCodigosAlternativos(Articulo) {
            return __awaiter(this, void 0, void 0, function* () {
                let vArticulos;
                try {
                    [vArticulos] = yield (0, api_1.api)('/Articulo/Articulos')
                        .parametros({
                        empgrupo_cod: this._model.Grupo,
                        emp_cod: this._model.Empresa,
                        codigoBarras: Articulo
                    })
                        .invoca();
                }
                catch ([vMensaje]) {
                    yield (0, mensaje_1.mensaje)().error().muestra(vMensaje);
                    return;
                }
                if (!vArticulos)
                    return Articulo;
                assert.esUnArrayDe(vArticulos, 'GAART_COD', 'GAART_DESCRIP');
                if (vArticulos.length === 1) {
                    return vArticulos[0].GAART_COD;
                }
                else {
                    const vArticulo = yield (0, lov_1.lov)()
                        .titulo(Resources.PantallaRecepcion.CodigosAlternativos.Lov.Titulo)
                        .columnas([
                        { propiedad: 'GAART_COD', titulo: Resources.PantallaRecepcion.CodigosAlternativos.Lov.Tabla.Codigo, ancho: '6em' },
                        { propiedad: 'GAART_DESCRIP', titulo: Resources.PantallaRecepcion.CodigosAlternativos.Lov.Tabla.Descripcion }
                    ])
                        .elige(vArticulos);
                    if (typeof vArticulo !== 'undefined')
                        return vArticulo.GAART_COD;
                }
            });
        }
    }
    exports.PantallaEntradas = PantallaEntradas;
});
