﻿define('expedicion-envios', ['expedicion-bultos'],
    function (Expedicion) {

        Expedicion.prototype.FocusTransport = function () {
            $(this./*exp*/inpCodTransportista).focus().select();
        };

        Expedicion.prototype.FocusVehicle = function () {
            $(this./*exp*/inpCodVehiculo).focus().select();
        };

        Expedicion.prototype.FocusBultos = function () {
            $(this./*exp*/inpCodTransportista).focus().select();
            $("#bultosInput").focus().select();
        };
        Expedicion.prototype.FocusPeso = function () {
            $("#pesoInput").focus().select();
        };
        Expedicion.prototype.FocusEtiquetas = function () {
            $("#etiquetasInput").focus().select();
        };

        Expedicion.prototype.CambioTransportista = function () {
            if ($(this./*exp*/inpCodTransportista).val() !== '') {
                var url = "expedicion/ModoEnvio";
                var datos = { empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"), emp_cod: sessionStorage.getItem("EMPR_COD"), GGMENVIO_COD: $(this./*exp*/inpCodTransportista).val() };
                var method = "GET";
                var success = (function (response, status, xhr) {
                    var Ok = (function () {
                        $('#codTransportistaInput').val(response.Objeto.COD);
                        $('#nombreTransportistaInput').val(response.Objeto.DESCRIP);
                        this./*exp*/LimpiarVehiculos();
                    }).bind(this);
                    var error = (function () {
                        $('#nombreTransportistaInput').val("");
                        this./*exp*/LimpiarVehiculos();
                        this./*exp*/FocusTransport();
                    }).bind(this);
                    handleResponse(response, Ok, error);
                }).bind(this);

                apiGeneral(url, method, datos, success);
            } else {
                $('#nombreTransportistaInput').val("");
                this./*exp*/LimpiarVehiculos();
            }
        };

        Expedicion.prototype.CambioVehiculo = function () {
            if ($(this./*exp*/inpCodVehiculo).val() !== '') {
                var url = "expedicion/Vehiculo";
                var v_datos = { empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"), emp_cod: sessionStorage.getItem("EMPR_COD"), ggmenvio_cod: $('#codTransportistaInput').val(), cod: $(this./*exp*/inpCodVehiculo).val() };
                var method = "GET";
                var success = (function (response) {
                    var Ok = function () {
                        $('#codVehiculoInput').val(response.Objeto.COD);
                        $('#descrVehiculoInput').val(response.Objeto.DESCRIP);
                    };
                    var error = (function () {
                        $('#descrVehiculoInput').val('');
                        this./*exp*/FocusVehicle();
                    }).bind(this);
                    handleResponse(response, Ok, error);
                }).bind(this);
                apiGeneral(url, method, v_datos, success);
            } else {
                this./*exp*/LimpiarVehiculos();
            }
        };

        Expedicion.prototype.SearchTransporter = function () {
            var url = "expedicion/ModosEnvio";
            var method = "GET";
            var datos = { empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"), emp_cod: sessionStorage.getItem("EMPR_COD") };
            var success = (function (response) {
                var Ok = (function () {
                    //var url = Router.action('Dialog', 'Dialog');
                    var url = "Dialog/Dialog";
                    var v_columns = [generateColumn('COD', Resources.table_head_code), generateColumn('DESCRIP', Resources.table_head_description)];
                    var columnDefs = [
                        { "width": "6em", "targets": 0 }
                    ];
                    var v_buttons = [generateSingleButton("datosEnvioAccept", Resources.button_accept)];
                    generarDialogAuto(url, "#dialogLoV", "tableTransporter", null, response.Objeto, v_columns, v_buttons, null, null, TransporterFunctions.bind(this), Resources.title_shipping_data, null, null, null, null, null, null, columnDefs, true);
                }).bind(this);
                handleResponse(response, Ok);
            }).bind(this);
            apiGeneral(url, method, datos, success);
        };

        Expedicion.prototype.SearchVehicle = function () {
            var url = "expedicion/Vehiculos";
            var datos = { empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"), emp_cod: sessionStorage.getItem("EMPR_COD"), ggmenvio_cod: $('#codTransportistaInput').prop('value') };
            var method = "GET";
            var success = (function (response) {
                var Ok = (function () {
                    //var url = Router.action('Dialog', 'Dialog');
                    var url = "Dialog/Dialog";
                    var v_columns = [generateColumn('COD', Resources.table_head_code), generateColumn('DESCRIP', Resources.table_head_description)];
                    var v_buttons = [generateSingleButton("datoEnvioAccept", Resources.button_accept)];
                    generarDialogAuto(url, "#dialogLoV", "tableVehicle", null, response.Objeto, v_columns, v_buttons, null, null, VehicleFunctions.bind(this), Resources.title_shipping_vehicle_data, null, null, null, null, null, null, null, true);
                }).bind(this);
                handleResponse(response, Ok);
            }).bind(this);
            apiGeneral(url, method, datos, success);
        };

        Expedicion.prototype.EnvioAceptar = function () {
            var url = "expedicion/Vehiculo";
            var v_datos = {
                empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
                emp_cod: sessionStorage.getItem("EMPR_COD"),
                ggmenvio_cod: $('#codTransportistaInput').val(),
                cod: $('#codVehiculoInput').val()
            };
            var method = "GET";
            var success = (function (response) {
                var Ok = (function () {
                    this./*exp*/DatosEnvio();
                    $('#dialogEnviosEtiquetas').modal('hide');
                    this.LanzarAlbaranes();
                }).bind(this);
                var error = function () {
                    $('#descrVehiculoInput').val('');
                };
                handleResponse(response, Ok, error);
            }).bind(this);
            apiGeneral(url, method, v_datos, success);
        };

        function TransporterFunctions() {
            $('.close').on("click", function () {
                closeModal("#dialogDatosEnvio");
            });
            $('#datosEnvioAccept').on("click", (function () {
                var v_table = $("#tableTransporter").DataTable();
                if (v_table.rows().data().length > 0) {
                    var v_codTransportista = v_table.rows('.selected').data()[0].COD;
                    var v_nombreTransportista = v_table.rows('.selected').data()[0].DESCRIP;
                    $('#codTransportistaInput').val(v_codTransportista);
                    $('#nombreTransportistaInput').val(v_nombreTransportista);
                    this./*exp*/LimpiarVehiculos();
                }
                closeModal('#dialogLoV');
            }).bind(this));
        };

        function VehicleFunctions() {
            $('.close').on("click", function () {
                closeModal("#dialogDatosEnvio");
            });
            $('#datoEnvioAccept').on("click", (function () {
                var v_table = $("#tableVehicle").DataTable();
                var v_data_table = v_table.rows('.selected').data();
                if (v_data_table.length !== 0) {
                    var v_codVehiculo = v_data_table[0].COD;
                    var v_descrVehiculo = v_data_table[0].DESCRIP;
                    if (v_table.rows().data().length > 0) {
                        $('#codVehiculoInput').val(v_codVehiculo);
                        $('#descrVehiculoInput').val(v_descrVehiculo);
                    }
                }
                closeModal('#dialogLoV');
            }).bind(this));
        };

        Expedicion.prototype.LimpiarVehiculos = function () {
            $('#codVehiculoInput').val("");
            $('#descrVehiculoInput').val("");
        };

        Expedicion.prototype.DatosEnvio = function () {
            $('#codTransporte').val($('#codTransportistaInput').val());
            $('#nombreTransporte').val($('#nombreTransportistaInput').val());
            $('#codVehiculo').val($('#codVehiculoInput').val());
            $('#descrVehiculo').val($('#descrVehiculoInput').val());
        };

        return Expedicion;
    });