﻿define('expedicion-cortina', ['expedicion-envios'],
    function (Expedicion) {

        var v_albaran = "";

        Expedicion.prototype.MenuInit = function () {
            //Inicializa el menu cada vez que se introduce un nuevo pedido dejando el botón de desconexión
            $('#nav-user').find('li:not(:first)').remove();
        };

        Expedicion.prototype.GenerarMenu = function () {
            this./*exp*/CambioAlbaran();

            menuInit();
            menuElement(Resources.menu_delivery_note_date, 'fecha', '#', dateToString(getDateAlb(this./*exp*/v_albaranSeleccionado)), 'buscador', 'menuDate', 'data-provide="datepicker"');
            menuElement(Resources.menu_delivery_note_change, 'observaciones', '#', v_albaran, 'buscador', 'menuAlbaran');
            menuElement(Resources.menu_packages, 'observaciones', '#', "Nº Bultos: " + this./*exp*/v_bultos.length, '', 'menuBultos');
            menuElement(Resources.menu_observations, 'observaciones', '#', "Mostrar", '', 'menuObservaciones');
            //Carga las fechas y genera el datePicker
            menuDatePicker();

            $("#tipoAlbaran").bind("change paste keyup", function () {
                this./*exp*/CambioAlbaran();
            });
            $("#numAlbaran").bind("change paste keyup", function () {
                this./*exp*/CambioAlbaran();
            });

            $('#menuAlbaran').on('click', function () {
                if (this./*exp*/data) {
                    //var url = Router.action('Dialog', 'Dialog');
                    var url = "Dialog/Dialog";

                    var v_columns = [generateColumn('GGALBTIP_COD', Resources.table_head_type),
                    generateColumn('N_ALBARAN', Resources.table_head_number, true, true),
                    generateColumn('F_ALBARAN', Resources.table_head_date),
                    generateColumn('GGESTADO_COD', Resources.table_head_state),
                    generateColumn('F_ALBARAN_HID', '', false)
                    ];
                    var columnDefs = [
                        { "width": "4em", "targets": 0 },
                        { "width": "4em", "targets": 1 },
                        { "width": "2em", "targets": 3 }
                    ];
                    var buttons = [generateSingleButton('seleccionarAlbaran', Resources.button_select, 'pull-right'), generateSingleButton('nuevoAlbaran', Resources.button_new, 'pull-left')];
                    var v_albaranes = this./*exp*/data.Albaranes.map(function (albaran) {
                        return {
                            GGALBTIP_COD: albaran.GGALBTIP_COD,
                            N_ALBARAN: albaran.N_ALBARAN,
                            //Fecha formateada para su visualización
                            F_ALBARAN: moment(albaran.F_ALBARAN).format(Globalize($("html").attr("lang")).culture().calendar.patterns.d.toUpperCase()),
                            GGESTADO_COD: albaran.GGESTADO_COD,
                            SU_REF_ALB: albaran.SU_REF_ALB,
                            //Fecha sin formatear (Oculto)
                            F_ALBARAN_HID: albaran.F_ALBARAN
                        };
                    });
                    generarDialogAuto(url, "#dialogLoV", 'tablaAlbaranes', null, v_albaranes, v_columns, buttons, null, null, this./*exp*/SelectAlbaran, Resources.title_delivery_note_selection, null, null, null, null, null, null, columnDefs);
                } else {
                    lanzarMensaje(false, Resources.error_insert_order);
                }
            });


            $('#menuBultos').on('click', function () {
                if (this./*exp*/data) {
                    this./*exp*/LanzarVentanaBultosDetail();
                } else {
                    lanzarMensaje(false, Resources.error_insert_order);
                }
            });

            $('#menuObservaciones').on('click', function () {
                if (this./*exp*/data) {
                    if (this./*exp*/data.OBSER && this./*exp*/data.OBSER.trim() !== "")
                        lanzarMensaje(true, this./*exp*/data.OBSER);
                    else
                        lanzarMensaje(true, Resources.message_no_observations);
                } else {
                    lanzarMensaje(false, Resources.error_insert_order);
                }
            });
        }

        Expedicion.prototype.ActualizarBultos = function () {
            $('#menuBultos div input').val(Resources.menu_package_quantity + ": " + this./*exp*/bulto.length);
        }

        return Expedicion;
    });