var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
define(["require", "exports", "utilidades/assert", "componentes/api", "componentes/componentes", "componentes/foco", "componentes/pantalla", "componentes/boton", "componentes/campo", "componentes/tabla", "Recepcion/modelos/pedido", "Recepcion/modelos/pantalla_modelo", "Recepcion/modelos/pedido_linea", "Recepcion/dialogos/js/dialogo-seleccion-albaran", "Recepcion/dialogos/modelos/dialogo-seleccion-albaran-modelo", "Recepcion/dialogos/js/dialogo-lotes-ubicaciones", "Recepcion/dialogos/modelos/dialogo-lotes-ubicaciones-modelo", "Recepcion/modelos/albaran", "Recepcion/dialogos/js/dialogo-datos-adicionales-albaran", "componentes/bloque"], function (require, exports, assert, api_1, componentes_1, foco_1, pantalla_1, boton_1, campo_1, tabla_1, pedido_1, pantalla_modelo_1, pedido_linea_1, dialogo_seleccion_albaran_1, dialogo_seleccion_albaran_modelo_1, dialogo_lotes_ubicaciones_1, dialogo_lotes_ubicaciones_modelo_1, albaran_1, dialogo_datos_adicionales_albaran_1, bloque_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.PantallaRecepcion = void 0;
    class PantallaRecepcion extends pantalla_1.Pantalla {
        constructor() {
            super();
            this.inicializa();
            this.asociaComponentes();
        }
        asociaComponentes() {
            const vComponentes = this.inicializaComponentes();
            Object.getOwnPropertyNames(vComponentes).forEach(pNombre => this[pNombre] = vComponentes[pNombre].crea());
            this.actualizaVista();
            return;
        }
        actualizaVista() {
            this._inputPedido.valor(this._DatosPantalla.ReferenciaPedido);
            this._inputReferencia.valor(this._DatosPantalla.ReferenciaArticulo);
            this._inputReferencia.habilitado(this._DatosPantalla.PedidoActivo);
            this._botonConfirmar.habilitado(this._DatosPantalla.PedidoActivo && this._PedidoPreparado.Lineas.length > 0);
            this._tabla.datos(this._Pedido.Lineas);
            this._tabla.buscaYSelecciona(null, { notificar: false });
            this._bloqueReferencia.clase('solo-referencia', !this._LineaSeleccionada || this._LineaSeleccionada.GAART_LOTES_SN === "S" || this._LineaSeleccionada.GAART_UBIC_SN === "S");
        }
        actualizaModelo() {
            this._DatosPantalla.ReferenciaPedido = this._inputPedido.valor();
            this._DatosPantalla.ReferenciaArticulo = this._inputReferencia.valor();
        }
        inicializa() {
            this._Pedido = new pedido_1.Pedido();
            this._DatosPantalla = new pantalla_modelo_1.DatosPantalla();
            this._PedidoPreparado = new pedido_1.PedidoPreparado({ EMPGRUPO_COD: this._DatosPantalla.Grupo, EMP_COD: this._DatosPantalla.Empresa });
            this._LineaSeleccionada = null;
        }
        inicializaComponentes() {
            foco_1.foco.enPrimero(document);
            const vComponentes = {
                _botonNuevo: (0, boton_1.boton)('btnNuevo')
                    .clic(() => {
                    this.nuevo();
                }),
                _botonConfirmar: (0, boton_1.boton)('btnConfirmar')
                    .clic(() => {
                    this.recepcionar();
                }),
                _inputPedido: (0, campo_1.campo)('txtPedido')
                    .cambio(() => __awaiter(this, void 0, void 0, function* () {
                    this.actualizaModelo();
                    yield this.ObtenerPedido.bind(this)();
                    this.actualizaVista();
                })),
                _inputReferencia: (0, campo_1.campo)('txtArticulo')
                    .valida(() => __awaiter(this, void 0, void 0, function* () {
                    this.actualizaModelo();
                    const vEncontrado = yield this.CambiarReferencia.bind(this)();
                    if (!vEncontrado)
                        foco_1.foco.en(this._inputReferencia);
                })),
                _inputCantidad: (0, campo_1.campo)('campCant')
                    .cambio(this.actualizaPreparadoArticuloSinLotesNiUbicaciones.bind(this)),
                _bloqueReferencia: (0, bloque_1.bloque)('ref'),
                _tabla: (0, tabla_1.tabla)('tablaPedidos')
                    .columnas([
                    { propiedad: 'GAART_COD', titulo: Resources.PantallaRecepcion.tabla.columna.GAART_COD, ancho: '6em' },
                    { propiedad: 'GAART_DESCRIP', titulo: Resources.PantallaRecepcion.tabla.columna.GAART_DESCRIP },
                    { propiedad: 'C_PDTE', titulo: Resources.PantallaRecepcion.tabla.columna.C_PDTE, numerico: true, ancho: '3em' },
                ])
                    .seleccionado((item) => __awaiter(this, void 0, void 0, function* () {
                    yield this.seleccionLinea(item);
                    this.actualizaVista();
                }))
            };
            return vComponentes;
        }
        nuevo() {
            this.inicializa();
            this.actualizaVista();
            this._inputPedido.foco();
        }
        ObtenerPedido() {
            return __awaiter(this, void 0, void 0, function* () {
                let vResultado;
                try {
                    [vResultado] = yield (0, api_1.api)('/Recepcion/Pedido')
                        .metodo('get')
                        .parametros({
                        EMPGRUPO_COD: this._DatosPantalla.Grupo,
                        EMP_COD: this._DatosPantalla.Empresa,
                        LecturaPedido: this._DatosPantalla.ReferenciaPedido
                    })
                        .invoca();
                }
                catch ([vMensaje]) {
                    yield (0, componentes_1.mensaje)().error().muestra(vMensaje);
                    foco_1.foco.en(this._inputPedido);
                    return;
                }
                assert.esUn(vResultado);
                this._Pedido = new pedido_1.Pedido(vResultado);
                this._DatosPantalla.AlbaranSeleccionado = yield this.ObtenerAlbaranes();
                if (!this._DatosPantalla.AlbaranSeleccionado) {
                    this._DatosPantalla.AlbaranSeleccionado = new albaran_1.Albaran();
                }
                this._DatosPantalla.PedidoActivo = true;
                if (this._Pedido.OBSER)
                    yield (0, componentes_1.mensaje)(this._Pedido.OBSER).muestra();
                foco_1.foco.en(this._inputReferencia);
            });
        }
        ObtenerAlbaranes() {
            return __awaiter(this, void 0, void 0, function* () {
                if (!this._Pedido.Albaranes || !this._Pedido.Albaranes.length)
                    return null;
                const vResultadoSeleccionAlbaran = yield (0, componentes_1.dialogo)()
                    .titulo(Resources.PantallaRecepcion.DialogoSeleccionAlbaran.Titulo)
                    .plantilla('recepcion/dialogos/plantillas/dialogo-seleccion-albaran')
                    .construye(pModal => new dialogo_seleccion_albaran_1.DialogoSeleccionAlbaran(new dialogo_seleccion_albaran_modelo_1.SeleccionAlbaranModel({ modal: pModal, albaranes: this._Pedido.Albaranes })))
                    .abre();
                return vResultadoSeleccionAlbaran;
            });
        }
        CambiarReferencia() {
            return __awaiter(this, void 0, void 0, function* () {
                this.actualizaModelo();
                if (!this._DatosPantalla.PedidoActivo) {
                    yield (0, componentes_1.mensaje)(Resources.error.select.order).muestra();
                    this.nuevo();
                    return;
                }
                let vSeleccionado = this.BuscarReferenciaEnTabla(this._DatosPantalla.ReferenciaArticulo);
                if (!vSeleccionado)
                    vSeleccionado = yield this.BuscarCodigosAlternativos(this._DatosPantalla.ReferenciaArticulo);
                if (!vSeleccionado) {
                    yield (0, componentes_1.mensaje)(Resources.PantallaRecepcion.notificacion.error.ArticuloNoEncontrado).muestra();
                }
                return vSeleccionado ? true : false;
            });
        }
        BuscarReferenciaEnTabla(Articulo) {
            const vSeleccionado = this._tabla.buscaYSelecciona({ GAART_COD: Articulo }, null);
            return vSeleccionado;
        }
        BuscarCodigosAlternativos(Articulo) {
            return __awaiter(this, void 0, void 0, function* () {
                let vArticulos;
                try {
                    [vArticulos] = yield (0, api_1.api)('/Articulo/Articulos')
                        .parametros({
                        empgrupo_cod: this._DatosPantalla.Grupo,
                        emp_cod: this._DatosPantalla.Empresa,
                        codigoBarras: Articulo
                    })
                        .invoca();
                }
                catch ([vMensaje]) {
                    yield (0, componentes_1.mensaje)().error().muestra(vMensaje);
                    return;
                }
                if (!vArticulos)
                    return;
                assert.esUnArrayDe(vArticulos, 'GAART_COD', 'GAART_DESCRIP');
                const vArticulosDelPedido = vArticulos.filter(pArticulo => this._Pedido.Lineas.find(pLinea => pLinea.GAART_COD === pArticulo.GAART_COD));
                let vGaartCod;
                if (vArticulosDelPedido.length === 1) {
                    vGaartCod = vArticulosDelPedido[0].GAART_COD;
                }
                else if (vArticulosDelPedido.length > 1) {
                    const vArticulo = yield (0, componentes_1.lov)()
                        .titulo(Resources.PantallaRecepcion.CodigosAlternativos.Lov.Titulo)
                        .columnas([
                        { propiedad: 'GAART_COD', titulo: Resources.PantallaRecepcion.CodigosAlternativos.Lov.Tabla.Codigo, ancho: '6em' },
                        { propiedad: 'GAART_DESCRIP', titulo: Resources.PantallaRecepcion.CodigosAlternativos.Lov.Tabla.Descripcion }
                    ])
                        .elige(vArticulosDelPedido);
                    if (typeof vArticulo !== 'undefined')
                        vGaartCod = vArticulo.GAART_COD;
                }
                const vSeleccionado = this.BuscarReferenciaEnTabla(vGaartCod);
                return vSeleccionado;
            });
        }
        seleccionLinea(item) {
            return __awaiter(this, void 0, void 0, function* () {
                this._LineaSeleccionada = item;
                if (this._LineaSeleccionada.GAART_LOTES_SN === "S" || this._LineaSeleccionada.GAART_UBIC_SN === "S") {
                    const vResultadoSeleccionLinea = yield (0, componentes_1.dialogo)()
                        .titulo(Resources.PantallaRecepcion.DialogoLotesUbicaciones.Titulo)
                        .plantilla('recepcion/dialogos/plantillas/dialogo-lotes-ubicaciones')
                        .construye(pModal => new dialogo_lotes_ubicaciones_1.DialogoLotesUbicaciones(new dialogo_lotes_ubicaciones_modelo_1.LotesUbicacionesModel({
                        modal: pModal,
                        Pedido: this._Pedido,
                        Linea: this._LineaSeleccionada
                    })))
                        .abre();
                    if (!vResultadoSeleccionLinea) {
                        foco_1.foco.en(this._inputReferencia);
                        return;
                    }
                    assert.esUn(vResultadoSeleccionLinea);
                    this.ActualizaCantidadesPedido(this._LineaSeleccionada, vResultadoSeleccionLinea);
                    foco_1.foco.en(this._inputReferencia);
                }
                else {
                    this._DatosPantalla.ReferenciaArticulo = this._LineaSeleccionada.GAART_COD;
                    this.actualizaVista();
                    this._inputCantidad.foco();
                }
            });
        }
        ActualizaCantidadesPedido(item, vResultadoSeleccionLinea) {
            item.Existencias = vResultadoSeleccionLinea.Disponible;
            item.C_PDTE -= vResultadoSeleccionLinea.Preparado.C_PREP;
            const vLinea = this._PedidoPreparado.Lineas.find(pLinea => pLinea.N_LIN === item.N_LIN);
            if (vLinea) {
                vLinea.C_UNI1 += vResultadoSeleccionLinea.Preparado.C_PREP;
                vResultadoSeleccionLinea.Preparado.Detalles.forEach(pItemPreparado => {
                    const vLineaEncontrada = vLinea.Detalles.find(pItemLinea => pItemPreparado.GAUBIC_COD === pItemLinea.GAUBIC_COD && pItemPreparado.LOTE === pItemLinea.LOTE);
                    if (vLineaEncontrada)
                        vLineaEncontrada.C_UNI1 += pItemPreparado.C_UNI1;
                    else
                        vLinea.Detalles.push(pItemPreparado);
                });
                item.Detalles = vLinea.Detalles;
            }
            else {
                this._PedidoPreparado.Lineas.push(new pedido_linea_1.PedidoLineaPreparada({
                    N_LIN: item.N_LIN,
                    C_UNI1: vResultadoSeleccionLinea.Preparado.C_PREP,
                    Detalles: vResultadoSeleccionLinea.Preparado.Detalles
                }));
                item.Detalles = vResultadoSeleccionLinea.Preparado.Detalles;
            }
        }
        actualizaPreparadoArticuloSinLotesNiUbicaciones(pValor) {
            return __awaiter(this, void 0, void 0, function* () {
                let vDisponible = this._LineaSeleccionada.Existencias;
                let vLineaPreparada = new dialogo_lotes_ubicaciones_modelo_1.LineaPreparada({ Disponible: vDisponible, Preparado: new dialogo_lotes_ubicaciones_modelo_1.DetallesLineaPreparada({ C_PREP: this._LineaSeleccionada.C_PREP || 0 + pValor }) });
                this.ActualizaCantidadesPedido(this._LineaSeleccionada, vLineaPreparada);
                this._LineaSeleccionada = null;
                this._inputCantidad.valor('');
                this.actualizaVista();
                this._inputReferencia.foco();
            });
        }
        ObtenerDatosAdicionalesAlbaran() {
            return __awaiter(this, void 0, void 0, function* () {
                const vDatosAdicionales = yield (0, componentes_1.dialogo)()
                    .titulo(Resources.PantallaRecepcion.DialogoDatosAdicionales.Titulo)
                    .plantilla('recepcion/dialogos/plantillas/dialogo-datos-adicionales-albaran')
                    .construye(pModal => new dialogo_datos_adicionales_albaran_1.DialogoDatosAdicionalesAlbaran(pModal, { SU_REF_ALB: this._DatosPantalla.AlbaranSeleccionado.SU_REF_ALB }))
                    .abre();
                assert.esUn(vDatosAdicionales);
                this._DatosPantalla.AlbaranSeleccionado.SU_REF_ALB = vDatosAdicionales.SU_REF_ALB;
            });
        }
        recepcionar() {
            return __awaiter(this, void 0, void 0, function* () {
                yield this.ObtenerDatosAdicionalesAlbaran();
                this._PedidoPreparado.F_ALBARAN = this._DatosPantalla.AlbaranSeleccionado.F_ALBARAN;
                this._PedidoPreparado.GGALBTIP_COD = this._DatosPantalla.AlbaranSeleccionado.GGALBTIP_COD;
                this._PedidoPreparado.N_ALBARAN = this._DatosPantalla.AlbaranSeleccionado.N_ALBARAN;
                this._PedidoPreparado.SU_REF_ALB = this._DatosPantalla.AlbaranSeleccionado.SU_REF_ALB;
                this._PedidoPreparado.GGPEDTIP_COD = this._Pedido.GGPEDTIP_COD;
                this._PedidoPreparado.N_PEDIDO = this._Pedido.N_PEDIDO;
                let vResultado;
                let vMensaje;
                try {
                    [vResultado, vMensaje] = yield (0, api_1.api)('/Recepcion/Recepcionar')
                        .metodo('post')
                        .parametros(this._PedidoPreparado)
                        .invoca();
                    yield (0, componentes_1.mensaje)().muestra(vMensaje);
                }
                catch ([vMensaje]) {
                    yield (0, componentes_1.mensaje)().error().muestra(vMensaje);
                }
                this.nuevo();
            });
        }
    }
    exports.PantallaRecepcion = PantallaRecepcion;
});
