var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
define(["require", "exports", "componentes/--plantilla", "componentes/modal", "componentes/componente-html"], function (require, exports, __plantilla_1, modal_1, componente_html_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.dialogo = exports.DefinicionDialogo = void 0;
    class Envoltura extends componente_html_1.ComponenteHTML {
        constructor(_elemento) {
            super(_elemento);
        }
        suprime() {
            this._elemento.remove();
        }
    }
    class DefinicionDialogo extends componente_html_1.ComponenteHTML {
        constructor(_valores) {
            super(_valores.elemento);
            this._valores = _valores;
        }
        titulo(p_titulo) {
            return new DefinicionDialogo(Object.assign(Object.assign({}, this._valores), { titulo: p_titulo }));
        }
        cancelable(p_cancelable) {
            return new DefinicionDialogo(Object.assign(Object.assign({}, this._valores), { cancelable: p_cancelable }));
        }
        plantilla(p_plantilla) {
            let v_plantilla;
            if (typeof p_plantilla === 'string')
                v_plantilla = { nombre: p_plantilla, secciones: {} };
            else
                v_plantilla = p_plantilla;
            return new DefinicionDialogo(Object.assign(Object.assign({}, this._valores), { plantilla: v_plantilla }));
        }
        elemento(p_elemento) {
            return new DefinicionDialogo(Object.assign(Object.assign({}, this._valores), { elemento: p_elemento }));
        }
        construye(p_construye) {
            return new DefinicionDialogo(Object.assign(Object.assign({}, this._valores), { construye: p_construye }));
        }
        estilos(p_estilos) {
            return new DefinicionDialogo(Object.assign(Object.assign({}, this._valores), { estilos: p_estilos }));
        }
        abre() {
            return __awaiter(this, void 0, void 0, function* () {
                let v_insertado;
                if (typeof this._valores.elemento !== 'undefined')
                    v_insertado = new Envoltura(this._valores.elemento);
                else {
                    const v_plantillaDialogo = yield (0, __plantilla_1.plantilla)(this._valores.plantilla).carga();
                    v_insertado = v_plantillaDialogo.inserta();
                }
                const v_elemento = v_insertado.elemento();
                let v_resultado;
                try {
                    v_resultado = yield (0, modal_1.modal)(v_elemento)
                        .titulo(this._valores.titulo)
                        .cancelable(this._valores.cancelable)
                        .construye(this._valores.construye)
                        .estilos(this._valores.estilos)
                        .abre();
                }
                finally {
                    v_insertado.suprime();
                }
                return v_resultado;
            });
        }
    }
    exports.DefinicionDialogo = DefinicionDialogo;
    function dialogo() {
        return new DefinicionDialogo({
            titulo: void 0,
            cancelable: true,
            plantilla: void 0,
            construye: p_modal => { }
        });
    }
    exports.dialogo = dialogo;
});
