var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
define(["require", "exports", "utilidades/assert", "componentes/api", "componentes/componentes", "componentes/foco", "componentes/boton", "componentes/campo", "componentes/pantalla"], function (require, exports, assert, api_1, componentes_1, foco_1, boton_1, campo_1, pantalla_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.PantallaInventario = void 0;
    class PantallaInventario extends pantalla_1.Pantalla {
        constructor() {
            super();
            this.inicializa();
            this.asociaComponentes();
        }
        asociaComponentes() {
            const vComponentes = this.inicializaComponentes();
            Object.getOwnPropertyNames(vComponentes).forEach(pNombre => this[pNombre] = vComponentes[pNombre].crea());
        }
        actualizaVista() {
            this._inputAlmacen.valor(this._modelo.GAALMNOM_COD);
            this._inputArticulo.valor(this._modelo.GAART_COD);
            this._inputArticuloDescrip.valor(this._modelo.GAART_DESCRIP);
            this._inputUbicacion.valor(this._modelo.GAUBIC_COD);
            this._inputLote.valor(this._modelo.Lote);
            this._inputExistencias.valor(this._modelo.Existencias);
            this._inputNuevas.valor(this._modelo.Cantidad);
            if (this._modelo.ControlUbicaciones === "N")
                this._inputUbicacion.deshabilita();
            else
                this._inputUbicacion.habilita();
            if (this._modelo.ControlLotes === "N")
                this._inputLote.deshabilita();
            else
                this._inputLote.habilita();
            this._botonConfirmar.habilitado(this.habilitarConfirmacion());
        }
        actualizaModelo() {
            this._modelo.GAALMNOM_COD = this._inputAlmacen.valor();
            this._modelo.GAART_COD = this._inputArticulo.valor();
            this._modelo.GAART_DESCRIP = this._inputArticuloDescrip.valor();
            this._modelo.GAUBIC_COD = this._inputUbicacion.valor();
            this._modelo.Lote = this._inputLote.valor();
            this._modelo.Existencias = this._inputExistencias.valor();
            this._modelo.Cantidad = this._inputNuevas.valor();
        }
        inicializa() {
            this._modelo = {
                EMP_COD: sessionStorage.getItem("EMPR_COD"),
                EMPGRUPO_COD: sessionStorage.getItem("EMPRGRUP_COD"),
                GAART_COD: "",
                GAART_DESCRIP: "",
                GAALMNOM_COD: "",
                GAALMNOM_DESCRIP: "",
                GAUBIC_COD: "",
                Lote: "",
                Existencias: null,
                Cantidad: null,
                ControlUbicaciones: "S",
                ControlLotes: "S"
            };
        }
        inicializaComponentes() {
            foco_1.foco.enPrimero(document);
            return {
                _botonNuevo: (0, boton_1.boton)('btnReset')
                    .clic(() => {
                    this.nuevo();
                }),
                _botonConfirmar: (0, boton_1.boton)('btnConfirmar')
                    .clic(() => __awaiter(this, void 0, void 0, function* () {
                    this.confirmar();
                }))
                    .tecla('Enter'),
                _inputAlmacen: (0, campo_1.campo)('txtAlmacen')
                    .lov(this.lovAlmacen.bind(this)),
                _btnBuscaAlmacen: (0, boton_1.boton)('btnBuscaAlmacen')
                    .clic(this.lovAlmacen.bind(this)),
                _inputArticulo: (0, campo_1.campo)('txtArt')
                    .cambio(() => __awaiter(this, void 0, void 0, function* () {
                    this.actualizaModelo();
                    this.obtenerArticulo.bind(this)();
                }))
                    .lov(this.lovArticulo.bind(this)),
                _btnArt: (0, boton_1.boton)('btnArt')
                    .clic(this.lovArticulo.bind(this)),
                _inputArticuloDescrip: (0, campo_1.campo)('txtArtDescr'),
                _inputUbicacion: (0, campo_1.campo)('txtUbic')
                    .cambio(() => __awaiter(this, void 0, void 0, function* () {
                    this.actualizaModelo();
                    if (this._modelo.ControlLotes === "N")
                        this.obtenerExistencias.bind(this)();
                }))
                    .lov(this.lovUbicacion.bind(this)),
                _btnUbic: (0, boton_1.boton)('btnUbic')
                    .clic(this.lovUbicacion.bind(this)),
                _inputLote: (0, campo_1.campo)('txtLote')
                    .cambio(() => __awaiter(this, void 0, void 0, function* () {
                    this.actualizaModelo();
                    this.obtenerExistencias.bind(this)();
                }))
                    .lov(this.lovLote.bind(this)),
                _btnLote: (0, boton_1.boton)('btnLote')
                    .clic(this.lovLote.bind(this)),
                _inputExistencias: (0, campo_1.campo)('txtExistAct1'),
                _inputNuevas: (0, campo_1.campo)('txtNuev1').cambio(() => {
                    this.actualizaModelo.bind(this)();
                    this.actualizaVista.bind(this)();
                })
            };
        }
        nuevo() {
            this.inicializa();
            this.actualizaVista();
            foco_1.foco.enPrimero(document);
        }
        habilitarConfirmacion() {
            if (this._modelo.Cantidad)
                return true;
            return false;
        }
        confirmar() {
            return __awaiter(this, void 0, void 0, function* () {
                this.actualizaModelo();
                let resultado = null;
                let vMensaje = null;
                [resultado, vMensaje] = yield this.confirmarInventario();
                console.log(resultado);
                (0, componentes_1.notificacion)().muestra(vMensaje);
                this.nuevo();
            });
        }
        lovArticulo() {
            return __awaiter(this, void 0, void 0, function* () {
                const vResultado = yield this.obtenerArticulos();
                const vElegido = yield (0, componentes_1.lov)()
                    .titulo('Artículos')
                    .columnas([
                    { propiedad: 'COD', titulo: 'Código', ancho: '6em' },
                    { propiedad: 'DESCRIP', titulo: 'Nombre' }
                ])
                    .elige(vResultado);
                this._modelo.GAART_COD = vElegido.COD;
                yield this.obtenerArticulo();
                this.actualizaVista();
            });
        }
        lovAlmacen() {
            return __awaiter(this, void 0, void 0, function* () {
                const vResultado = yield this.obtenerAlmacenes();
                const vElegido = yield (0, componentes_1.lov)()
                    .titulo('Almacenes')
                    .columnas([
                    { propiedad: 'COD', titulo: 'Código', ancho: '6em' },
                    { propiedad: 'DESCRIP', titulo: 'Nombre' }
                ])
                    .elige(vResultado);
                if (vElegido) {
                    this._modelo.Existencias = null;
                    this._modelo.GAUBIC_COD = null;
                    this._modelo.Lote = null;
                    this._modelo.Cantidad = null;
                    this._modelo.ControlUbicaciones = "S";
                    this._modelo.ControlLotes = "S";
                    this._modelo.GAALMNOM_COD = vElegido.COD;
                    this._modelo.GAALMNOM_DESCRIP = vElegido.DESCRIP;
                    this.actualizaVista();
                    foco_1.foco.enPrimero(document);
                }
            });
        }
        lovUbicacion() {
            return __awaiter(this, void 0, void 0, function* () {
                const vResultado = yield this.obtenerUbicaciones();
                const vElegido = yield (0, componentes_1.lov)()
                    .titulo('Lotes')
                    .columnas([
                    { propiedad: 'COD', titulo: 'Código' }
                ])
                    .elige(vResultado);
                if (vElegido) {
                    this._modelo.GAUBIC_COD = vElegido.COD;
                    this._modelo.Lote = null;
                    this._modelo.Existencias = null;
                    this._modelo.Cantidad = null;
                    if (this._modelo.ControlLotes === "N")
                        yield this.obtenerExistencias();
                    this.actualizaVista();
                }
            });
        }
        lovLote() {
            return __awaiter(this, void 0, void 0, function* () {
                const vResultado = yield this.obtenerLotes();
                const vElegido = yield (0, componentes_1.lov)()
                    .titulo('Lotes')
                    .columnas([
                    { propiedad: 'COD', titulo: 'Código' }
                ])
                    .elige(vResultado);
                if (vElegido) {
                    this._modelo.Lote = vElegido.COD;
                    yield this.obtenerExistencias();
                }
            });
        }
        obtenerArticulo() {
            return __awaiter(this, void 0, void 0, function* () {
                let vResultado;
                try {
                    [vResultado] = yield (0, api_1.api)('/Inventario/Articulo')
                        .metodo('get')
                        .parametros({
                        EMPGRUPO_COD: this._modelo.EMPGRUPO_COD,
                        EMP_COD: this._modelo.EMP_COD,
                        GAALMNOM_COD: this._modelo.GAALMNOM_COD,
                        lecturaArticulo: this._modelo.GAART_COD
                    })
                        .invoca();
                }
                catch ([vMensaje]) {
                    yield (0, componentes_1.mensaje)().error().muestra(vMensaje);
                    this._inputArticulo.foco();
                    return;
                }
                assert.esUn(vResultado, "COD", "DESCRIP", "UBIC_SN", "LOTES_SN", "C_EXIST1", "C_EXIST2");
                this._modelo.GAART_COD = vResultado.COD;
                this._modelo.GAART_DESCRIP = vResultado.DESCRIP;
                this._modelo.Existencias = vResultado.C_EXIST1;
                this._modelo.GAUBIC_COD = null;
                this._modelo.Lote = null;
                this._modelo.Cantidad = null;
                this._modelo.ControlUbicaciones = vResultado.UBIC_SN;
                this._modelo.ControlLotes = vResultado.LOTES_SN;
                if (this._modelo.ControlUbicaciones === "N" && this._modelo.ControlLotes === "N")
                    this.obtenerExistencias();
                this.actualizaVista();
                return vResultado;
            });
        }
        obtenerArticulos() {
            return __awaiter(this, void 0, void 0, function* () {
                let vResultado;
                try {
                    [vResultado] = yield (0, api_1.api)('/Inventario/Articulos')
                        .metodo('get')
                        .parametros({
                        EMPGRUPO_COD: this._modelo.EMPGRUPO_COD,
                        EMP_COD: this._modelo.EMP_COD,
                        GAALMNOM_COD: this._modelo.GAALMNOM_COD
                    })
                        .invoca();
                }
                catch ([vMensaje]) {
                    yield (0, componentes_1.mensaje)().error().muestra(vMensaje);
                    return;
                }
                assert.esUnArrayDe(vResultado, "COD", "DESCRIP");
                return vResultado;
            });
        }
        obtenerExistencias() {
            return __awaiter(this, void 0, void 0, function* () {
                let vResultado;
                try {
                    [vResultado] = yield (0, api_1.api)('/Inventario/Existencias')
                        .metodo('get')
                        .parametros({
                        EMPGRUPO_COD: this._modelo.EMPGRUPO_COD,
                        EMP_COD: this._modelo.EMP_COD,
                        GAALMNOM_COD: this._modelo.GAALMNOM_COD,
                        LecturaArticulo: this._modelo.GAART_COD,
                        GAUBIC_COD: this._modelo.GAUBIC_COD,
                        Lote: this._modelo.Lote
                    })
                        .invoca();
                }
                catch ([vMensaje]) {
                    yield (0, componentes_1.mensaje)().error().muestra(vMensaje);
                    return;
                }
                assert.esUn(vResultado, "C_EXIST1", "C_EXIST2");
                this._modelo.Existencias = vResultado.C_EXIST1;
                this.actualizaVista();
                return vResultado;
            });
        }
        obtenerAlmacenes() {
            return __awaiter(this, void 0, void 0, function* () {
                let vResultado;
                try {
                    [vResultado] = yield (0, api_1.api)('/Inventario/Almacenes')
                        .metodo('get')
                        .parametros({
                        EMPGRUPO_COD: this._modelo.EMPGRUPO_COD,
                        EMP_COD: this._modelo.EMP_COD
                    })
                        .invoca();
                }
                catch ([vMensaje]) {
                    yield (0, componentes_1.mensaje)().error().muestra(vMensaje);
                    return;
                }
                assert.esUnArrayDe(vResultado, "COD", "DESCRIP");
                return vResultado;
            });
        }
        obtenerUbicaciones() {
            return __awaiter(this, void 0, void 0, function* () {
                let vResultado;
                try {
                    [vResultado] = yield (0, api_1.api)('/Inventario/Ubicaciones')
                        .metodo('get')
                        .parametros({
                        EMPGRUPO_COD: this._modelo.EMPGRUPO_COD,
                        EMP_COD: this._modelo.EMP_COD,
                        GAALMNOM_COD: this._modelo.GAALMNOM_COD
                    })
                        .invoca();
                }
                catch ([vMensaje]) {
                    yield (0, componentes_1.mensaje)().error().muestra(vMensaje);
                    return;
                }
                assert.esUnArrayDe(vResultado, "COD");
                return vResultado;
            });
        }
        obtenerLotes() {
            return __awaiter(this, void 0, void 0, function* () {
                let vResultado;
                try {
                    [vResultado] = yield (0, api_1.api)('/Inventario/Lotes')
                        .metodo('get')
                        .parametros({
                        EMPGRUPO_COD: this._modelo.EMPGRUPO_COD,
                        EMP_COD: this._modelo.EMP_COD,
                        GAALMNOM_COD: this._modelo.GAALMNOM_COD,
                        GAART_COD: this._modelo.GAART_COD
                    })
                        .invoca();
                }
                catch ([vMensaje]) {
                    yield (0, componentes_1.mensaje)().error().muestra(vMensaje);
                    return;
                }
                assert.esUnArrayDe(vResultado, "COD");
                return vResultado;
            });
        }
        obtenerAlmacen() {
            return __awaiter(this, void 0, void 0, function* () {
                let vResultado;
                try {
                    [vResultado] = yield (0, api_1.api)('/Movimientos/Almacen')
                        .metodo('get')
                        .parametros({
                        EMPGRUPO_COD: this._modelo.EMPGRUPO_COD,
                        EMP_COD: this._modelo.EMP_COD,
                        GAALMNOM_COD: this._modelo.GAALMNOM_COD
                    })
                        .invoca();
                }
                catch ([vMensaje]) {
                    yield (0, componentes_1.mensaje)().error().muestra(vMensaje);
                    return;
                }
                assert.esUn(vResultado, "COD", "DESCRIP", "GAUBIC_DEF", "LOTE_DEF");
                return vResultado;
            });
        }
        obtenerUbicacion() {
            return __awaiter(this, void 0, void 0, function* () {
                let vResultado;
                try {
                    [vResultado] = yield (0, api_1.api)('/Movimientos/Ubicacion')
                        .metodo('get')
                        .parametros({
                        EMPGRUPO_COD: this._modelo.EMPGRUPO_COD,
                        EMP_COD: this._modelo.EMP_COD,
                        GAALMNOM_COD: this._modelo.GAALMNOM_COD,
                        GAUBIC_COD: this._modelo.GAUBIC_COD,
                        Lote: this._modelo.Lote
                    })
                        .invoca();
                }
                catch ([vMensaje]) {
                    yield (0, componentes_1.mensaje)().error().muestra(vMensaje);
                    return;
                }
                assert.esUn(vResultado, "COD", "DESCRIP", "GAUBIC_DEF", "LOTE_DEF");
                return vResultado;
            });
        }
        cambioArticulo() {
            return __awaiter(this, void 0, void 0, function* () {
                let vResultado;
                try {
                    [vResultado] = yield (0, api_1.api)('/Movimientos/Articulo')
                        .metodo('get')
                        .parametros({
                        EMPGRUPO_COD: this._modelo.EMPGRUPO_COD,
                        EMP_COD: this._modelo.EMP_COD,
                        GAALMNOM_COD: this._modelo.GAALMNOM_COD,
                        GAUBIC_COD: this._modelo.GAUBIC_COD,
                        Lote: this._modelo.Lote,
                        LecturaArticulo: this._modelo.GAART_COD
                    })
                        .invoca();
                }
                catch ([vMensaje]) {
                    yield (0, componentes_1.mensaje)().error().muestra(vMensaje);
                    return;
                }
                assert.esUn(vResultado, "COD", "DESCRIP", "GAUBIC_DEF", "LOTE_DEF");
                return vResultado;
            });
        }
        confirmarInventario() {
            return __awaiter(this, void 0, void 0, function* () {
                let vResultado;
                let vMensaje;
                try {
                    [vResultado, vMensaje] = yield (0, api_1.api)('/Inventario/ActualizarRecuento')
                        .metodo('put')
                        .parametros({
                        EMPGRUPO_COD: this._modelo.EMPGRUPO_COD,
                        EMP_COD: this._modelo.EMP_COD,
                        GAALMNOM_COD: this._modelo.GAALMNOM_COD,
                        GAART_COD: this._modelo.GAART_COD,
                        GAUBIC_COD: this._modelo.GAUBIC_COD,
                        LOTE: this._modelo.Lote,
                        C_UNID1: this._modelo.Cantidad
                    })
                        .invoca();
                }
                catch ([vMensaje]) {
                    yield (0, componentes_1.mensaje)().error().muestra(vMensaje);
                    return;
                }
                return [vResultado, vMensaje];
            });
        }
    }
    exports.PantallaInventario = PantallaInventario;
});
