var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
define(["require", "exports", "componentes/pregunta"], function (require, exports, pregunta_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.mensaje = void 0;
    class Mensaje {
        constructor(_texto, _error) {
            this._texto = _texto;
            this._error = _error;
        }
        texto(p_texto) {
            if (typeof p_texto !== 'string') {
                throw new Error('No es un texto válido');
            }
            return new Mensaje(p_texto, this._error);
        }
        ;
        error() {
            return new Mensaje(this._texto, true);
        }
        ;
        muestra(p_texto) {
            return __awaiter(this, void 0, void 0, function* () {
                const v_texto = typeof p_texto === 'string' ? p_texto : this._texto;
                let v_pregunta = (0, pregunta_1.pregunta)(v_texto)
                    .opciones(['Aceptar'])
                    .opcionPredeterminada('Aceptar');
                if (this._error)
                    v_pregunta = v_pregunta.error();
                return yield v_pregunta.muestra();
            });
        }
        ;
    }
    function mensaje(p_texto) {
        if (arguments.length === 0) {
            p_texto = '';
        }
        return new Mensaje(p_texto, false);
    }
    exports.mensaje = mensaje;
});
